; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_INITIALISIERUNG:
.equ SAMPLING=22000000/(16*13)
;	ldi temp,(0<<REFS1)|(0<<REFS0))|(1<<ADLAR) 	; ext REF			
;	ldi temp,(0<<REFS1)|(1<<REFS0)|(1<<ADLAR)  	; AVCC + KAPAZITT	
	ldi temp,(1<<REFS1)|(0<<REFS0)|(1<<ADLAR) 	; 1,1V				
;	ldi temp,(1<<REFS1)|(1<<REFS0)|(1<<ADLAR) 	; 2,56V				
	STS ADMUX, temp
;-------------------------------------------------------------------------------
; "FREE Running" + Vorteiler (zw. 50kHz...200kHz)														
;	ldi temp,(0<<ADPS2)|(0<<ADPS1)|(0<<ADPS0) ;  2	
;	ldi temp,(0<<ADPS2)|(0<<ADPS1)|(1<<ADPS0) ;  2	
;	ldi temp,(0<<ADPS2)|(1<<ADPS1)|(0<<ADPS0) ;  4	
;ldi temp,(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0) ;  8	
ldi temp,(1<<ADPS2)|(0<<ADPS1)|(0<<ADPS0) ; 16*
;ldi temp,(1<<ADPS2)|(0<<ADPS1)|(1<<ADPS0) ; 32	
;ldi temp,(1<<ADPS2)|(1<<ADPS1)|(0<<ADPS0) ; 64	
;ldi temp,(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0) ; 128
	ldi temp1,(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIF)|(0<<ADIE)
	or temp,temp1
	STS ADCSRA,temp       
;-------------------------------------------------------------------------------
	ldi temp,((0<<ACME)|(0<<ADTS2)|(0<<ADTS1)|(0<<ADTS0)) 
	STS ADCSRB,temp
;-------------------------------------------------------------------------------
	LDS temp,ADMUX
	andi temp,0b11100000	
	subi temp, -0			; ADC0
;	ori  temp,0b00011110	;  11110 	1.1V (VBG)
;	ori  temp,0b00011111	;  11111 	 0 V (GND)
	STS ADMUX,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_INTERRUPT_ON:
	LDS temp,ADCSRA
	ldi temp1,(1<<ADIE)
	or temp,temp1
	STS ADCSRA,temp  
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_INTERRUPT_OFF:
	call ADC_INITIALISIERUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-Interrupt, Register mssen nicht gesichert werden							
ADCI:
;	LDS temp,ADCL								; zuerst das LOW-Byte	
	LDS PWMI,ADCH								; dann das HIGH BYTE	
	STS PWM_NF,PWMI								; PWM					
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################

