; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_ANZEIGE_SDHC:
	LDS temp,(adr_SD_SDHC_AKTIV)	
	tst temp
	brne SD_INFO_w
	call ASCII_MINUS3
	jmp  ASCII_MINUS3
;-------------------------------------------------------------------------------
SD_INFO_w:
	jmp TEXT_SDHC
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_SEKTOR_VIEW:
	call TFT_CLEAR
	call SEKTOR_NULL
	call WAIT_200ms
;-------------------------------------------------------------------------------
SD_SEKTOR_VIEW_s:
	call SD_SEKTOR_READ			; read		
;-------------------------------------------------------------------------------
	call ZEILE1
	call TEXT_SEKTOR
	call ANZEIGE_SEKTOR_HEX_KURZ
;-------------------------------------------------------------------------------
	call ZEILE2
	LDS temp1,(adr_SD_DATA+0)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_SD_DATA+1)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_SD_DATA+2)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_SD_DATA+3)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_SD_DATA+4)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_SD_DATA+5)
	call ZAHL_HEX_TEMP1
;-------------------------------------------------------------------------------
;	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	call SEKTOR_PLUS_EINS
;-------------------------------------------------------------------------------
;	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	call SEKTOR_MINUS_EINS
;-------------------------------------------------------------------------------
;	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)			; springe, wenn BIT(PIN) HIGH
	ret
;-------------------------------------------------------------------------------
	rjmp SD_SEKTOR_VIEW_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_READ:
	call TFT_CLEAR
	call SEKTOR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_s:
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_s1:
	call SD_SEKTOR_READ			; read		
	call SEKTOR_PLUS_EINS		; +1		
;-------------------------------------------------------------------------------
SD_TEST_READ_w:
	call ZAHLER_PLUS_EINS
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_READ_s1
;-------------------------------------------------------------------------------
	call ZEILE1				; Zeile	
	call TEXT_READ
	call TEXT_TEST
;-------------------------------------------------------------------------------
	call ZEILE2				; Zeile	
	call ANZEIGE_ZAEHLER_KURZ
	call TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
;	TASTE_F_GEDRUECKT		; Taste ?	
	ret
;-------------------------------------------------------------------------------
	rjmp SD_TEST_READ_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_READ_MULTIPLE:
	call TFT_CLEAR
	call SEKTOR_NULL
	call SD_SEKTOR_READ_MULTIPLE_START
;-------------------------------------------------------------------------------
SD_TEST_READ_MULTIPLE_s:
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_READ_MULTIPLE_s1:
	call SD_SEKTOR_READ_MULTIPLE_DATA	; read		
	call ZAHLER_PLUS_EINS
	call SEKTOR_PLUS_EINS				; +1		
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_READ_MULTIPLE_s1
;-------------------------------------------------------------------------------
	call ZEILE1				; Zeile	
	call TEXT_READ
	call TEXT_MULTIPLE
	call ZEILE2				; Zeile	
;-------------------------------------------------------------------------------
	call ANZEIGE_ZAEHLER_KURZ
	call TEXT_SEC_PRO_SEC
;-------------------------------------------------------------------------------
;	TASTE_F_GEDRUECKT		; Taste ?	
	rjmp SD_SEKTOR_READ_MULTIPLE_STOP			; STOP						
;-------------------------------------------------------------------------------
	rjmp SD_TEST_READ_MULTIPLE_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE:
	call TFT_CLEAR
 	call ZUFALLSZAHL_TEMP		; Kontrollbyte
	call SD_DATA_CLEAR
	call SEKTOR_NULL
	call ZAHLER_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_WRITE_s:
	STS(adr_SD_DATA+0),SEKTOR3		; DATA			
	STS(adr_SD_DATA+1),SEKTOR2
	STS(adr_SD_DATA+2),SEKTOR1
	STS(adr_SD_DATA+3),SEKTOR0
	LDS temp,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	STS(adr_SD_DATA+4),temp
	call SD_SEKTOR_WRITE		; write	
	call ZAHLER_PLUS_EINS
	call SEKTOR_PLUS_EINS		; +1	
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_WRITE_s
;-------------------------------------------------------------------------------
	call ZEILE1				; Zeile	
	call TEXT_WRITE
	call TEXT_TEST
;-------------------------------------------------------------------------------
	call ZEILE2				; Zeile	
	call ANZEIGE_ZAEHLER_KURZ
	call TEXT_SEC_PRO_SEC
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	call ZAHL_HEX_TEMP1
;-------------------------------------------------------------------------------
;	TASTE_F_GEDRUECKT		; Taste ?	
	ret
;-------------------------------------------------------------------------------
	call ZAHLER_NULL
	call UHR_NULL
	rjmp SD_TEST_WRITE_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE_MULTIPLE:
	call TFT_CLEAR
	call ZUFALLSZAHL_TEMP		; Kontrollbyte
	call SD_DATA_CLEAR
	call SEKTOR_NULL
	call ZAHLER_NULL
	call UHR_NULL
	call SD_SEKTOR_WRITE_MULTIPLE_START	; START !!!
;-------------------------------------------------------------------------------
SD_TEST_WRITE_MULTIPLE_s:
	STS(adr_SD_DATA+0),SEKTOR3				; DATA			
	STS(adr_SD_DATA+1),SEKTOR2
	STS(adr_SD_DATA+2),SEKTOR1
	STS(adr_SD_DATA+3),SEKTOR0
	LDS temp,(adr_ZUFALLSZAHL)			; Kontrollbyte	
	STS(adr_SD_DATA+4),temp
	call SD_SEKTOR_WRITE_MULTIPLE_DATA	; DATA !!!
	call ZAHLER_PLUS_EINS
	call SEKTOR_PLUS_EINS				; +1	
;-------------------------------------------------------------------------------
	LDS temp,(adr_ss)
	tst temp
	breq SD_TEST_WRITE_MULTIPLE_s
;-------------------------------------------------------------------------------
	call ZEILE1				; Zeile	
	call TEXT_WRITE
	call TEXT_MULTIPLE
;-------------------------------------------------------------------------------
	call ZEILE2				; Zeile	
	call ANZEIGE_ZAEHLER_KURZ
	call TEXT_SEC_PRO_SEC
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	call ZAHL_HEX_TEMP1
;-------------------------------------------------------------------------------
;	TASTE_F_GEDRUECKT		; Taste ?	
	rjmp SD_SEKTOR_WRITE_MULTIPLE_STOP	; STOP !!!
;-------------------------------------------------------------------------------
	call ZAHLER_NULL
	call UHR_NULL
	rjmp SD_TEST_WRITE_MULTIPLE_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_TEST_WRITE_READ:
 	call TFT_CLEAR
 	call ZUFALLSZAHL_TEMP		; Kontrollbyte
	call SD_DATA_CLEAR
	call SEKTOR_NULL
	call UHR_NULL
;-------------------------------------------------------------------------------
SD_TEST_WRITE_READ_s:
	STS(adr_SD_DATA+0),SEKTOR3		; DATA			
	STS(adr_SD_DATA+1),SEKTOR2
	STS(adr_SD_DATA+2),SEKTOR1
	STS(adr_SD_DATA+3),SEKTOR0
	LDS temp,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	STS(adr_SD_DATA+4),temp
	call SD_SEKTOR_WRITE		; write	
;-------------------------------------------------------------------------------
	call SD_SEKTOR_READ			; read		
	LDS temp,(adr_SD_DATA+0)
	cp temp,SEKTOR3				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_SD_DATA+1)
	cp temp,SEKTOR2				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_SD_DATA+2)
	cp temp,SEKTOR1				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_SD_DATA+3)
	cp temp,SEKTOR0				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	LDS temp,(adr_SD_DATA+4)
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte
	cp temp,temp1				; Vegleich	
	brne SD_TEST_WRITE_ERROR
	rjmp SD_TEST_WRITE_READ_w
;-------------------------------------------------------------------------------
SD_TEST_WRITE_ERROR:
	call TFT_CLEAR
	call TEXT_ERROR
	call ZEILE3
	call TEXT_SEKTOR
	call ANZEIGE_SEKTOR_HEX_KURZ
	LED_ROT_AN
	call WAIT_100ms
;-------------------------------------------------------------------------------
SD_TEST_WRITE_READ_w:
	call SEKTOR_PLUS_EINS		; +1	
	tst SEKTOR0
	brne SD_TEST_WRITE_READ_s
;-------------------------------------------------------------------------------
	call ZEILE1				; Zeile	
	call TEXT_TEST
	call TEXT_WRITE
	call TEXT_READ
	call ZEILE2				; Zeile	
	call ANZEIGE_SEKTOR_HEX_KURZ
	call ZEILE3				; Zeile	
	call SD_PROZENT
	call ZEILE4				; Zeile	
	call SD_MB
	call ZEILE5				; Zeile	
	call ANZEIGE_ZEIT_KURZ
	call ZEILE6				; Zeile	
	LDS temp1,(adr_ZUFALLSZAHL)	; Kontrollbyte	
	call ZAHL_HEX_TEMP1
;-------------------------------------------------------------------------------
;	TASTE_F_GEDRUECKT		; Taste ?	
	ret
	rjmp SD_TEST_WRITE_READ_s	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Anzeige in %																	
SD_PROZENT:
	mov temp1,SEKTOR0				; Divident	
	mov temp2,SEKTOR1
	mov temp3,SEKTOR2
	mov temp4,SEKTOR3

	LDS temp5,(adr_SD_SEKTOR_MAX0)	; Divisor	
	LDS temp6,(adr_SD_SEKTOR_MAX1)
	LDS temp7,(adr_SD_SEKTOR_MAX2)
	LDS temp8,(adr_SD_SEKTOR_MAX3)
; ------------------------------------------------------------------------------
; Divisor auf 16 Bit krzen														
SD_PROZENT_s2:	
	LSR temp4				; Divident :2		
	ROR temp3
	ROR temp2
	ROR temp1
	LSR temp8				; Divisor :2		
	ROR temp7
	ROR temp6
	ROR temp5
	tst temp7				; noch 24 Bit?		
	brne SD_PROZENT_s2
	tst temp8				; noch 32 Bit?		
	brne SD_PROZENT_s2
; ------------------------------------------------------------------------------
	ldi temp3,LOW (100)
	ldi temp4,high(100)
	call MULTIPLIKATION_16_16_32	; Divident x 100
	call DIVISION_32_16				; Division		
	call ZAHL_TEMP1_2_3_4		; Ergebnis		
	call ASCII_PROZENT
	call ASCII_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_MB:
	mov temp1,SEKTOR0				
	mov temp2,SEKTOR1
	mov temp3,SEKTOR2
	mov temp4,SEKTOR3
	call TEMP1_2_3_4_MAL_512		; x 512
	call TEMP1_2_3_4_DURCH_1000
	call TEMP1_2_3_4_DURCH_1000
	call ZAHL_TEMP1_2_3_4		; Ergebnis		
	call TEXT_MB
	call ASCII_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
