; #############################################################################
; #############################################################################
; #############################################################################
GRAFIC_TASTEN_ABFRAGEN:
	WDR
	STS(adr_TASTE),NULL	
	sbic (TFT_PIN),(TFT_PIN_NR)	; springe, wenn BIT(PIN) low
	ret
;------------------------------------------------------------------------------
	BEEP_AN
	rcall PAKET_DISPLAY_SENDEPUFFER_ANFORDERN_TEMP1_SRAM	; INHALT_SENDEPUFFER_ANFORDERN	
	tst temp1												; Daten vorhanden ?				
	brne TASTEN_ABFRAGEN_RUN
	ret
;------------------------------------------------------------------------------
; Tasteninformation auslesen													
TASTEN_ABFRAGEN_RUN:
	LDS temp,(adr_GRAFIC_PUFFER256+0)
	cpi temp,27	; ESC	
	brne TASTEN_ABFRAGEN_FERTIG
	LDS temp,(adr_GRAFIC_PUFFER256+1)
	cpi temp,'A'; "A"	
	brne TASTEN_ABFRAGEN_FERTIG
	LDS temp,(adr_GRAFIC_PUFFER256+2)
	cpi temp,1	; 1		
	brne TASTEN_ABFRAGEN_FERTIG
	LDS temp1,(adr_GRAFIC_PUFFER256+3)
;------------------------------------------------------------------------------
	STS(adr_TASTE),temp1	; Tastenwert	
	BEEP_AUS
	LED_ROT_AUS
	LED_GELB_AUS
	LED_GRUEN_AUS
	LED_STEREO_AUS
	LED_ROT2_AUS
	LED_GELB2_AUS
	LED_GRUEN2_AUS
;------------------------------------------------------------------------------
TASTEN_ABFRAGEN_FERTIG:
ret
; #############################################################################
; #############################################################################
; #############################################################################
; ESC A L Cod n1																	
;Der Touchbereich mit dem Return-Code (Code=0: alle) wird aus der Abfrage entfernt.	
;Mit n1=0 bleibt der Bereich am Display sichtbar, mit n1=1 wird der Bereich gelscht.
TASTEN_CLEAR:
	rcall ASCII_ESC	; ESC senden	
	rcall ASCII_A
	rcall ASCII_L
	rcall ASCII_NULL
	rcall ASCII_EINS
	rjmp PAKET_SENDEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Rahmentyp einstellen ESC A E n1												
TASTEN_RAHMENTYP_DUNKEL:
	rcall ASCII_ESC 
	rcall ASCII_A
	rcall ASCII_E
	rjmp  ASCII_ZWEI
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Rahmentyp einstellen ESC A E n1												
TASTEN_RAHMENTYP_HELL:
	rcall ASCII_ESC 
	rcall ASCII_A
	rcall ASCII_E
	rjmp  ASCII_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display 160x104																
; TASTE: ESC A T x1 y1 x2 y2 dowCod upCod Text NULL								
; Eine TASTE definieren															
;																				
;	INP: Z (TABELLE)															
; X, Y, dX, dY, dowCod, TEXT, NULL												
;																				
TASTE_DEFINIEREN_Z:
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_A
	rcall ASCII_T
;-------------------------------------------
	LPM temp, Z+  		; X			
	mov temp1,temp		; save		
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp2, Z+  		; Y			
	ldi temp,104-1
	sub temp,temp2
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  		; dX		
	add temp,temp1
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp3, Z+  		; dY		
	ldi temp,104-1
	sub temp,temp2
	sub temp,temp3
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  		; dowCod	
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	rcall ASCII_NULL	; upCod		
;-------------------------------------------
	rcall ASCII_C		; zentriert
;-------------------------------------------
TASTE_DEFINIEREN_s:
	LPM temp, Z+  		; TEXT		
	tst temp			; NULL ?		
	breq TASTE_DEFINIEREN_EXIT
	rcall PAKET_DATA_TEMP
	rjmp TASTE_DEFINIEREN_s
;-------------------------------------------
TASTE_DEFINIEREN_EXIT:
	rcall ASCII_NULL	; NULL				
	rjmp PAKET_SENDEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_JA_NEIN_C:
	call TFT_CLEAR
	call GRAFIC_TASTEN_ABFRAGEN
	call TASTEN_JA_NEIN_DEFINIEREN
;-------------------------------------------------------------------------------
TASTEN_JA_NEIN_s:
	WDR
	sbic (TFT_PIN),(TFT_PIN_NR)	; springe, wenn BIT(PIN) low
	rjmp TASTEN_JA_NEIN_s
;------------------------------------------------------------------------------
	call GRAFIC_TASTEN_ABFRAGEN
	LDS temp,(adr_TASTE)
	cpi temp,0
	breq TASTEN_JA_NEIN_s
;-------------------------------------------------------------------------------
	cpi temp,1
	breq TASTEN_JA
;-------------------------------------------------------------------------------
TASTEN_Nein:
	CLC ;Clear Carry	
	ret
;-------------------------------------------------------------------------------
TASTEN_JA:
	SEC ;Set Carry		
ret
; #############################################################################
; #############################################################################
; #############################################################################
TASTE_SENDER_DEFINIEREN_Z_TEMP1:
	push temp1
	rcall ASCII_ESC	; ESC senden
	rcall ASCII_A
	rcall ASCII_T
;-------------------------------------------
	LPM temp, Z+  		; X			
	mov temp1,temp		; save		
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp2, Z+  		; Y			
	ldi temp,104-1
	sub temp,temp2
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  		; dX		
	add temp,temp1
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp3, Z+  		; dY		
	ldi temp,104-1
	sub temp,temp2
	sub temp,temp3
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	LPM temp, Z+  		; dowCod	
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	rcall ASCII_NULL	; upCod		
;-------------------------------------------
	rcall ASCII_C		; zentriert
;-------------------------------------------
	pop temp1
	ldi ZL,low (adr_SENDER_TASTE200)
	ldi ZH,high(adr_SENDER_TASTE200)
	ldi temp2,20
	MUL temp1,temp2
	add ZL,R0
	adc ZH,R1
;-------------------------------------------
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
	LD temp,Z+
	rcall PAKET_DATA_TEMP
;-------------------------------------------
	rcall ASCII_NULL	; NULL				
	rjmp PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; INP/OUT temp1...temp4															
EDIT_ZAHL_TEMP1_2_3_4:
	push ZL
	push ZH

	STS(adr_EINGABE_ZAHL_BYTE0),temp1		; save	
	STS(adr_EINGABE_ZAHL_BYTE1),temp2
	STS(adr_EINGABE_ZAHL_BYTE2),temp3
	STS(adr_EINGABE_ZAHL_BYTE3),temp4

	STS(adr_EINGABE_ZAHLESC_BYTE0),temp1	; save	
	STS(adr_EINGABE_ZAHLESC_BYTE1),temp2
	STS(adr_EINGABE_ZAHLESC_BYTE2),temp3
	STS(adr_EINGABE_ZAHLESC_BYTE3),temp4

	call TFT_CLEAR
	call TASTEN_ZAHLENFELD_INITIALISIERUNG
	call ZEILE1
;-------------------------------------------------------------------------------
EDIT_ZAHL_s:
	call ZEILE2
	LDS temp1,(adr_EINGABE_ZAHL_BYTE0)
	LDS temp2,(adr_EINGABE_ZAHL_BYTE1)
	LDS temp3,(adr_EINGABE_ZAHL_BYTE2)
	LDS temp4,(adr_EINGABE_ZAHL_BYTE3)
	call ZAHL10_TEMP1_2_3_4
;-------------------------------------------------------------------------------
EDIT_ZAHL_T:
	WDR
	sbic (TFT_PIN),(TFT_PIN_NR)	; springe, wenn BIT(PIN) low
	rjmp EDIT_ZAHL_T
;------------------------------------------------------------------------------
	call GRAFIC_TASTEN_ABFRAGEN
	LDS temp,(adr_TASTE)
	cpi temp,111		; DEL	
	breq EDIT_ZAHL_DEL
	cpi temp,112		; ESC	
	breq  EDIT_ZAHL_ESC	
	cpi temp,113		; ok	
	breq EDIT_ZAHL_OK
;-------------------------------------------------------------------------------
	subi temp,100		; -100	
	LDS temp1,(adr_EINGABE_ZAHL_BYTE0)
	LDS temp2,(adr_EINGABE_ZAHL_BYTE1)
	LDS temp3,(adr_EINGABE_ZAHL_BYTE2)
	LDS temp4,(adr_EINGABE_ZAHL_BYTE3)
	call TEMP1_2_3_4_MAL_10
	add temp1,temp
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(adr_EINGABE_ZAHL_BYTE0),temp1
	STS(adr_EINGABE_ZAHL_BYTE1),temp2
	STS(adr_EINGABE_ZAHL_BYTE2),temp3
	STS(adr_EINGABE_ZAHL_BYTE3),temp4
	rjmp EDIT_ZAHL_s
;-------------------------------------------------------------------------------
EDIT_ZAHL_ESC:	
	LDS temp1,(adr_EINGABE_ZAHLESC_BYTE0)
	LDS temp2,(adr_EINGABE_ZAHLESC_BYTE1)
	LDS temp3,(adr_EINGABE_ZAHLESC_BYTE2)
	LDS temp4,(adr_EINGABE_ZAHLESC_BYTE3)
	STS(adr_EINGABE_ZAHL_BYTE0),temp1
	STS(adr_EINGABE_ZAHL_BYTE1),temp2
	STS(adr_EINGABE_ZAHL_BYTE2),temp3
	STS(adr_EINGABE_ZAHL_BYTE3),temp4
	rjmp EDIT_ZAHL_OK
;-------------------------------------------------------------------------------
EDIT_ZAHL_DEL:	
	LDS temp1,(adr_EINGABE_ZAHL_BYTE0)
	LDS temp2,(adr_EINGABE_ZAHL_BYTE1)
	LDS temp3,(adr_EINGABE_ZAHL_BYTE2)
	LDS temp4,(adr_EINGABE_ZAHL_BYTE3)
	call TEMP1_2_3_4_DURCH_10
	STS(adr_EINGABE_ZAHL_BYTE0),temp1
	STS(adr_EINGABE_ZAHL_BYTE1),temp2
	STS(adr_EINGABE_ZAHL_BYTE2),temp3
	STS(adr_EINGABE_ZAHL_BYTE3),temp4
	rjmp EDIT_ZAHL_s
;-------------------------------------------------------------------------------
EDIT_ZAHL_OK:
	call TFT_CLEAR
	LDS temp1,(adr_EINGABE_ZAHL_BYTE0)
	LDS temp2,(adr_EINGABE_ZAHL_BYTE1)
	LDS temp3,(adr_EINGABE_ZAHL_BYTE2)
	LDS temp4,(adr_EINGABE_ZAHL_BYTE3)
	POP ZH
	POP ZL
ret
; #############################################################################
; #############################################################################
; #############################################################################
