; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZEIT_KURZ:
	LDS temp1,(adr_hh)
	call ZAHL2_TEMP1
	call ASCII_DOPPELPUNKT
	LDS temp1,(adr_mm)
	call ZAHL2_TEMP1
	call ASCII_DOPPELPUNKT
	LDS temp1,(adr_ss)
	jmp ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_RDS_ZEIT_KURZ:
	LDS temp,(adr_RDS_ZEIT_HH)
	tst temp
	brne ANZEIGE_RDS_ZEIT_KURZ_RUN
	LDS temp,(adr_RDS_ZEIT_MM)
	tst temp
	brne ANZEIGE_RDS_ZEIT_KURZ_RUN
	jmp ASCII_UNTERSTRICH5
;-------------------------------------------------------------------------------
ANZEIGE_RDS_ZEIT_KURZ_RUN:
	LDS temp1,(adr_RDS_ZEIT_HH)
	call ZAHL2_TEMP1
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_RDS_ZEIT_MM)
	jmp  ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_DATUM_KURZ:
	LDS temp1,(adr_TAG)
	call ZAHL2_TEMP1
	call ASCII_PUNKT

	LDS temp1,(adr_MONAT)
	call ZAHL2_TEMP1
	call ASCII_PUNKT

	LDS temp1,(adr_JAHR)
	jmp ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_RDS_DATUM_KURZ:
	LDS temp,(adr_RDS_TAG)
	tst temp
	brne ANZEIGE_RDS_DATUM_KURZ_w
	jmp ASCII_UNTERSTRICH8
;-------------------------------------------------------------------------------
ANZEIGE_RDS_DATUM_KURZ_w:
	LDS temp1,(adr_RDS_TAG)
	call ZAHL2_TEMP1
	call ASCII_PUNKT

	LDS temp1,(adr_RDS_MONAT)
	call ZAHL2_TEMP1
	call ASCII_PUNKT

	LDS temp1,(adr_RDS_JAHR)
	jmp ZAHL2_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_WOCHENTAG_KURZ:
	LDS temp,(adr_WOCHENTAG)
	cpi temp,1
	breq ANZEIGE_WOCHENTAG1
	cpi temp,2
	breq ANZEIGE_WOCHENTAG2
	cpi temp,3
	breq ANZEIGE_WOCHENTAG3
	cpi temp,4
	breq ANZEIGE_WOCHENTAG4
	cpi temp,5
	breq ANZEIGE_WOCHENTAG5
	cpi temp,6
	breq ANZEIGE_WOCHENTAG6
	cpi temp,7
	breq ANZEIGE_WOCHENTAG7
	jmp ASCII_UNTERSTRICH2
ANZEIGE_WOCHENTAG1:
	call ASCII_M
	jmp  ASCII_o_
ANZEIGE_WOCHENTAG2:
	call ASCII_D
	jmp  ASCII_i_
ANZEIGE_WOCHENTAG3:
	call ASCII_M
	jmp  ASCII_i_
ANZEIGE_WOCHENTAG4:
	call ASCII_D
	jmp  ASCII_o_
ANZEIGE_WOCHENTAG5:
	call ASCII_F
	jmp  ASCII_r_
ANZEIGE_WOCHENTAG6:
	call ASCII_S
	jmp  ASCII_a_
ANZEIGE_WOCHENTAG7:
	call ASCII_S
	jmp  ASCII_o_
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1...4 Anzahl Sektoren												
; OUT: hh:mm:ss																	
ANZEIGE_REC_ZEIT_TEMP1_2_3_4:
	tst temp4
	brpl ANZEIGE_REC_w
	call ASCII_MINUS8
	jmp PAKET_SENDEN
;-------------------------------------------------------------------------------
ANZEIGE_REC_w:
	ldi temp5,low (207)
	ldi temp6,high(207)
	call DIVISION_32_16	
;-------------------------------------------------------------------------------
	ldi temp9,(-1)
ANZEIGE_REC_hh:	
	inc temp9
	subi temp1, BYTE1    (3600)
	sbci temp2, BYTE2    (3600)
	sbci temp3, BYTE3    (3600)
	sbci temp4, BYTE4    (3600)
	brcc ANZEIGE_REC_hh
	subi temp1, BYTE1   (-3600)
	sbci temp2, BYTE2   (-3600)
	sbci temp3, BYTE3   (-3600)
	sbci temp4, BYTE4   (-3600)
	push temp9
;-------------------------------------------------------------------------------
	ldi temp9,(-1)
ANZEIGE_REC_mm:	
	inc temp9
	subi temp1, BYTE1    (60)
	sbci temp2, BYTE2    (60)
	sbci temp3, BYTE3    (60)
	sbci temp4, BYTE4    (60)
	brcc ANZEIGE_REC_mm
	subi temp1, BYTE1   (-60)
	sbci temp2, BYTE2   (-60)
	sbci temp3, BYTE3   (-60)
	sbci temp4, BYTE4   (-60)
	push temp9
;-------------------------------------------------------------------------------
	mov temp9,temp1
	push temp9
;-------------------------------------------------------------------------------
	pop temp1
	pop temp2
	pop temp3
	push temp1
	push temp2
	push temp3
;-------------------------------------------------------------------------------
	pop temp1
	call ZAHL2_TEMP1
	call ASCII_DOPPELPUNKT
	pop temp1
	call ZAHL2_TEMP1
	call ASCII_DOPPELPUNKT
	pop temp1
	call ZAHL2_TEMP1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; REC_LEER			= 0	(???????)												
; REC_HAND			= 1	(Hand   )												
; REC_TIMER			= 2	(Timer  )												
; REC_TP			= 3	(Verkehr)												
ANZEIGE_REC_MODUS_TEMP:
	cpi temp,1
	breq ANZEIGE_REC_MODUS1
	cpi temp,2
	breq ANZEIGE_REC_MODUS2
	cpi temp,3
	breq ANZEIGE_REC_MODUS3
;-------------------------------------------------------------------------------
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	jmp  ASCII_FRAGEZEICHEN
;-------------------------------------------------------------------------------
ANZEIGE_REC_MODUS1:
	call ASCII_H
	call ASCII_a_
	call ASCII_n_
	call ASCII_d_
	call ASCII_SPACE 
	call ASCII_SPACE 
	jmp  ASCII_SPACE
;-------------------------------------------------------------------------------
ANZEIGE_REC_MODUS2:
	call ASCII_T
	call ASCII_i_
	call ASCII_m_
	call ASCII_e_
	call ASCII_r_
	call ASCII_SPACE 
	jmp  ASCII_SPACE
;-------------------------------------------------------------------------------
ANZEIGE_REC_MODUS3:
	call ASCII_V
	call ASCII_e_
	call ASCII_r_
	call ASCII_k_
	call ASCII_e_
	call ASCII_h_
	jmp  ASCII_r_
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SEKTOR_HEX_KURZ:
	call ASCII_x_
	tst SEKTOR3
	brne ANZEIGE_SEKTOR3
	tst SEKTOR2
	brne ANZEIGE_SEKTOR2
	jmp ANZEIGE_SEKTOR1
;-------------------------------------------------------------------------------
ANZEIGE_SEKTOR3:
	mov temp1,SEKTOR3
	call ZAHL_HEX_TEMP1
ANZEIGE_SEKTOR2:
	mov temp1,SEKTOR2
	call ZAHL_HEX_TEMP1
ANZEIGE_SEKTOR1:
	mov temp1,SEKTOR1
	call ZAHL_HEX_TEMP1
ANZEIGE_SEKTOR0:
	mov temp1,SEKTOR0
	call ZAHL_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SEKTOR_DEZ_KURZ:
	call SEKTOR_NACH_TEMP1_4
	jmp ZAHL_TEMP1_2_3_4
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bsp 61="01:01"																
ANZEIGE_ZEITZAHL_TEMP1_2:
	ldi temp9,(-1)
ANZEIGE_ZEITZAHL_s:
	inc temp9
	subi temp1, BYTE1    (60)
	sbci temp2, BYTE2    (60)
	brcc ANZEIGE_ZEITZAHL_s
	subi temp1, BYTE1   (-60)
	sbci temp2, BYTE2   (-60)
;-------------------------------------------------------------------------------
	push temp1
	mov temp1,temp9
	call ZAHL2_TEMP1
	call ASCII_DOPPELPUNKT
	pop temp1
	call ZAHL2_TEMP1
	jmp ASCII_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZAEHLER_KURZ:
	LDS temp1,(adr_ZAEHLER0)
	LDS temp2,(adr_ZAEHLER1)
	LDS temp3,(adr_ZAEHLER2)
	LDS temp4,(adr_ZAEHLER3)
	call ZAHL_TEMP1_2_3_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "MDR THUE" oder "FM__97,4"												
ANZEIGE_SENDERNAME_KURZ:
	LDS temp1,(adr_TUNE_FREQUENZ_L)
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	clr temp3
	clr temp4
 	call FUNKTION_HEX_ASC_32
	call FUNKTION_FORMAT

	LDS temp,(adr_MODUS_AM_FM)
	cpi temp,(MODUS_LW)
	breq ANZEIGE_SENDERNAME_LW
	cpi temp,(MODUS_MW)
	breq ANZEIGE_SENDERNAME_MW
	cpi temp,(MODUS_KW)
	breq ANZEIGE_SENDERNAME_KW
	cpi temp,(MODUS_FM)
	breq ANZEIGE_SENDERNAME_FM
	ret	
ANZEIGE_SENDERNAME_LW:
	ldi temp8,'L'
	ldi temp7,'W'
	jmp ANZEIGE_SENDERNAME_FERTIG
ANZEIGE_SENDERNAME_MW:
	ldi temp8,'M'
	ldi temp7,'W'
	jmp ANZEIGE_SENDERNAME_FERTIG
ANZEIGE_SENDERNAME_KW:
	ldi temp8,'K'
	ldi temp7,'W'
	jmp ANZEIGE_SENDERNAME_FERTIG
;-------------------------------------------------------------------------------
ANZEIGE_SENDERNAME_FM:
	LDS temp,(adr_RDS_SENDERNAME8+0)
	cpi temp,'_'
	brne ANZEIGE_SENDERNAME_FM_RDS
	LDS temp,(adr_RDS_SENDERNAME8+2)
	cpi temp,'_'
	brne ANZEIGE_SENDERNAME_FM_RDS
	LDS temp,(adr_RDS_SENDERNAME8+4)
	cpi temp,'_'
	brne ANZEIGE_SENDERNAME_FM_RDS
	LDS temp,(adr_RDS_SENDERNAME8+6)
	cpi temp,'_'
	brne ANZEIGE_SENDERNAME_FM_RDS
	jmp ANZEIGE_SENDERNAME_FM_FREQUENZ
;-------------------------------------------------------------------------------
ANZEIGE_SENDERNAME_FM_RDS:
	LDS temp8,(adr_RDS_SENDERNAME8+0)
	LDS temp7,(adr_RDS_SENDERNAME8+1)
	LDS temp6,(adr_RDS_SENDERNAME8+2)
	LDS temp5,(adr_RDS_SENDERNAME8+3)
	LDS temp4,(adr_RDS_SENDERNAME8+4)
	LDS temp3,(adr_RDS_SENDERNAME8+5)
	LDS temp2,(adr_RDS_SENDERNAME8+6)
	LDS temp1,(adr_RDS_SENDERNAME8+7)
	jmp ANZEIGE_SENDERNAME_FERTIG
;-------------------------------------------------------------------------------
ANZEIGE_SENDERNAME_FM_FREQUENZ:
	LDS temp1,(adr_TUNE_FREQUENZ_L)
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	clr temp3
	clr temp4
 	call FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ldi temp8,'F'
	ldi temp7,'M'
	ldi temp6,'_'	
	cpi temp5,'0'
	brne ANZEIGE_SENDERNAME_FREQUENZ_AM_FM_KURZ_FM_w
	ldi temp5,'_'
ANZEIGE_SENDERNAME_FREQUENZ_AM_FM_KURZ_FM_w:
	mov temp1,temp2
	ldi temp2,','
	jmp ANZEIGE_SENDERNAME_FERTIG
;-------------------------------------------------------------------------------
ANZEIGE_SENDERNAME_FERTIG:
	STS(adr_SENDERNAME8+0),temp8			; in SRAM ablegen	
	STS(adr_SENDERNAME8+1),temp7
	STS(adr_SENDERNAME8+2),temp6
	STS(adr_SENDERNAME8+3),temp5
	STS(adr_SENDERNAME8+4),temp4
	STS(adr_SENDERNAME8+5),temp3
	STS(adr_SENDERNAME8+6),temp2
	STS(adr_SENDERNAME8+7),temp1



	LDS temp,(adr_SENDERNAME8+0)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+1)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+2)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+3)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+4)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+5)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+6)
	call PAKET_DATA_TEMP
	LDS temp,(adr_SENDERNAME8+7)
	call PAKET_DATA_TEMP
	jmp PAKET_SENDEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B: "_92.1"																
ANZEIGE_FREQUENZ_AM_FM_KURZ:
	LDS temp,(adr_MODUS_AM_FM)
	cpi temp,(MODUS_FM)
	breq ANZEIGE_FREQUENZ_AM_FM_KURZ_FM
	LDS temp1,(adr_TUNE_FREQUENZ_L)	; AM							
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	jmp ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
ANZEIGE_FREQUENZ_AM_FM_KURZ_FM:
	LDS temp1,(adr_TUNE_FREQUENZ_L)	; FM							
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	jmp ZAHL5_KOMMA2_TEMP1_2
; #############################################################################
; #############################################################################
; #############################################################################
ANZEIGE_MUSIK_SPRACHE_KURZ:
	LDS temp,(adr_RDS_MS)
	tst temp
	brne ANZEIGE_MUSIK_SPRACHE_KURZ_MUSIK
ANZEIGE_MUSIK_SPRACHE_KURZ_SPRACHE:
	call ASCII_S
	call ASCII_P
	call ASCII_R
	call ASCII_A
	call ASCII_C
	call ASCII_H
	call ASCII_E
ret
;-------------------------------------------------------------------------------
ANZEIGE_MUSIK_SPRACHE_KURZ_MUSIK:
	call ASCII_M
	call ASCII_U
	call ASCII_S
	call ASCII_I
	call ASCII_K
	call ASCII_SPACE2
ret
; #############################################################################
; #############################################################################
; #############################################################################
ANZEIGE_TP_KURZ:
	LDS temp,(adr_RDS_TP)
	tst temp
	brne ANZEIGE_TP_KURZ_AKTIV
	jmp ASCII_SPACE2
;-------------------------------------------------------------------------------
ANZEIGE_TP_KURZ_AKTIV:
	call ASCII_T
	jmp  ASCII_P
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Verkehrsdurchsage																
ANZEIGE_TA_KURZ:
	LDS temp,(adr_RDS_TA)
	tst temp
	brne ANZEIGE_TA_AKTIV
	jmp ASCII_SPACE2
;-------------------------------------------------------------------------------
ANZEIGE_TA_AKTIV:
	call ASCII_T
	jmp  ASCII_A
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "D318"																	
ANZEIGE_PI_KURZ:
	LDS temp,(adr_RDS_PI_H)
	tst temp
	brne ANZEIGE_PI_KURZ_OK
	LDS temp,(adr_RDS_PI_L)
	tst temp
	brne ANZEIGE_PI_KURZ_OK
	jmp ASCII_UNTERSTRICH4
ANZEIGE_PI_KURZ_OK:
	LDS temp1,(adr_RDS_PI_H)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_RDS_PI_L)
	jmp ZAHL_HEX_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_PI_TEXT_KURZ:
	LDS temp,(adr_RDS_PI_H)
	tst temp
	brne ANZEIGE_PI_TEXT_KURZ_RUN
	jmp ASCII_UNTERSTRICH4
;-------------------------------------------------------------------------------
ANZEIGE_PI_TEXT_KURZ_RUN:
	; Z-initialisieren	
	LDS temp,(adr_RDS_PI_L)
	SWAP temp
	andi temp,0b00001111
	LSL  temp 	; x2
	ldi ZL,LOW (ANZEIGE_PI_TEXT_KURZ_SPRUNGMARKE)
	ldi ZH,HIGH(ANZEIGE_PI_TEXT_KURZ_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
;-------------------------------------------------------------------------------
ANZEIGE_PI_TEXT_KURZ_SPRUNGMARKE:
	call ASCII_B; "Baden-Wrttemberg"
	jmp  ASCII_W
ANZEIGE_PI_TEXT_KURZ_1:
	call ASCII_B;"Bayern"
	jmp  ASCII_Y
ANZEIGE_PI_TEXT_KURZ_2:
	call ASCII_B;"Berlin"
	jmp  ASCII_E
ANZEIGE_PI_TEXT_KURZ_3:
	call ASCII_B;"Brandenburg"
	jmp  ASCII_B
ANZEIGE_PI_TEXT_KURZ_4:
	call ASCII_H;"Bremen"
	jmp  ASCII_B
ANZEIGE_PI_TEXT_KURZ_5:
	call ASCII_H;"Hamburg"
	jmp  ASCII_H
ANZEIGE_PI_TEXT_KURZ_6:
	call ASCII_H;"Hessen"
	jmp  ASCII_E
ANZEIGE_PI_TEXT_KURZ_7:
	call ASCII_M;"Mecklenburg-Vorpommern"
	jmp  ASCII_V
ANZEIGE_PI_TEXT_KURZ_8:
	call ASCII_N;"Niedersachsen"
	jmp  ASCII_I
ANZEIGE_PI_TEXT_KURZ_9:
	call ASCII_N;"Nordrhein-Westfalen"
	jmp  ASCII_W
ANZEIGE_PI_TEXT_KURZ_A:
	call ASCII_R;"Rheinland-Pfalz"
	jmp  ASCII_P
ANZEIGE_PI_TEXT_KURZ_B:
	call ASCII_S;"Saarland"
	jmp  ASCII_L
ANZEIGE_PI_TEXT_KURZ_C:
	call ASCII_S;"Sachsen"
	jmp  ASCII_N
ANZEIGE_PI_TEXT_KURZ_D:
	call ASCII_S;"Sachsen-Anhalt"
	jmp  ASCII_T
ANZEIGE_PI_TEXT_KURZ_E:
	call ASCII_S;"Schleswig-Holstein"
	jmp  ASCII_H
ANZEIGE_PI_TEXT_KURZ_F:
	call ASCII_T;"Thringen"
	jmp  ASCII_H
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_PTY_TEXT_KURZ:
	LDS temp1,(adr_RDS_PTY)
	ldi temp,4
	mul temp1,temp
	ldi ZL,LOW (ANZEIGE_PTY_TEXT_SPRUNGMARKE)
	ldi ZH,HIGH(ANZEIGE_PTY_TEXT_SPRUNGMARKE)
	add ZL,R0
	adc ZH,R1
	ijmp			; SPRUNG nach Z	
;-------------------------------------------------------------------------------
ANZEIGE_PTY_TEXT_SPRUNGMARKE:
	ldi ZH, high(TEXT_PTY_00*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_00*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_01:
	ldi ZH, high(TEXT_PTY_01*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_01*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_02:
	ldi ZH, high(TEXT_PTY_02*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_02*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_03:
	ldi ZH, high(TEXT_PTY_03*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_03*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_04:
	ldi ZH, high(TEXT_PTY_04*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_04*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_05:
	ldi ZH, high(TEXT_PTY_05*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_05*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_06:
	ldi ZH, high(TEXT_PTY_06*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_06*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_07:
	ldi ZH, high(TEXT_PTY_07*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_07*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_08:
	ldi ZH, high(TEXT_PTY_08*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_08*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_09:
	ldi ZH, high(TEXT_PTY_09*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_09*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_10:
	ldi ZH, high(TEXT_PTY_10*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_10*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_11:
	ldi ZH, high(TEXT_PTY_11*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_11*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_12:
	ldi ZH, high(TEXT_PTY_12*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_12*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_13:
	ldi ZH, high(TEXT_PTY_13*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_13*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_14:
	ldi ZH, high(TEXT_PTY_14*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_14*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_15:
	ldi ZH, high(TEXT_PTY_15*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_15*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_16:
	ldi ZH, high(TEXT_PTY_16*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_16*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_17:
	ldi ZH, high(TEXT_PTY_17*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_17*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_18:
	ldi ZH, high(TEXT_PTY_18*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_18*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_19:
	ldi ZH, high(TEXT_PTY_19*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_19*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_20:
	ldi ZH, high(TEXT_PTY_20*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_20*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_21:
	ldi ZH, high(TEXT_PTY_21*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_21*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_22:
	ldi ZH, high(TEXT_PTY_22*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_22*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_23:
	ldi ZH, high(TEXT_PTY_23*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_23*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_24:
	ldi ZH, high(TEXT_PTY_24*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_24*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_25:
	ldi ZH, high(TEXT_PTY_25*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_25*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_26:
	ldi ZH, high(TEXT_PTY_26*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_26*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_27:
	ldi ZH, high(TEXT_PTY_27*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_27*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_28:
	ldi ZH, high(TEXT_PTY_28*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_28*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_29:
	ldi ZH, high(TEXT_PTY_29*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_29*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_30:
	ldi ZH, high(TEXT_PTY_30*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_30*2)
	jmp ASCII_TEXT_Z
ANZEIGE_PTY_TEXT_31:
	ldi ZH, high(TEXT_PTY_31*2)	; TEXT 
	ldi ZL,  low(TEXT_PTY_31*2)
	jmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ANZAHL_AF_KURZ:
	call ASCII_A
	call ASCII_F
	call ASCII_DOPPEL_PUNKT
	; Z-Initialisieren	
	ldi ZL,LOW (adr_RDS_BEREICH_AF205)
	ldi ZH,HIGH(adr_RDS_BEREICH_AF205)
	clr temp1			; Anzahl	
	ldi temp9,204		; Schleife	
	; Anzah AF ermitteln
ANZEIGE_ANZAHL_AF_KURZ_s:
	LD temp,Z+
	tst temp
	breq ANZEIGE_ANZAHL_AF_KURZ_w
	inc temp1
ANZEIGE_ANZAHL_AF_KURZ_w:
	dec temp9
	brne ANZEIGE_ANZAHL_AF_KURZ_s
	jmp ZAHL_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_RADIOTEXT1_KURZ:
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT128)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT128)
	ldi temp1,20
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT2_KURZ:
	ldi temp1,20	; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT3_KURZ:
	ldi temp1,20	; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT4_KURZ:
	ldi temp1,4		; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT5_KURZ:
	ldi temp1,20	; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT6_KURZ:
	ldi temp1,20	; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT7_KURZ:
	ldi temp1,20	; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
ANZEIGE_RADIOTEXT8_KURZ:
	ldi temp1,4		; Anzahl
	jmp ANZEIGE_TEXT_Z_TEMP1_KURZ
;-------------------------------------------------------------------------------
ANZEIGE_TEXT_Z_TEMP1_KURZ:
	LD temp,Z+	; temp laden und Z+1
	call PAKET_DATA_TEMP
	dec temp1
	brne ANZEIGE_TEXT_Z_TEMP1_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_GET_PROPERTY_TEMP1_2_KURZ:


	call ASCII_X
	mov temp,temp2
	call ZAHL_HEX_TEMP1	; ?????????
	mov temp,temp1
	call ZAHL_HEX_TEMP1 ; ?????
	call ASCII_ISTGLEICH

	call SI4735_GET_PROPERTY_TEMP1_2

	; Hexadezimal	
	call ASCII_X
	mov temp,temp2
	call ZAHL_HEX_TEMP1
	mov temp,temp1
	call ZAHL_HEX_TEMP1
	call ASCII_SPACE
	; DEZIMAL		
	call ZAHL_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ON_OFF_TEMP:
	tst temp
	brne ANZEIGE_ON_OFF_w
	call ASCII_o_
	call ASCII_f_
	jmp  ASCII_f_
ANZEIGE_ON_OFF_w:
	call ASCII_MINUS3
	call ASCII_SPACE
	call ASCII_O
	call ASCII_N
	call ASCII_SPACE
	jmp ASCII_MINUS3
; ##############################################################################
ANZEIGE_MO_TEMP:
	tst temp
	brne ANZEIGE_MO_TEMP_w
	jmp  ASCII_SPACE3
ANZEIGE_MO_TEMP_w:
	call ASCII_M
	call ASCII_o_
	jmp  ASCII_SPACE
; ##############################################################################
ANZEIGE_DI_TEMP:
	tst temp
	brne ANZEIGE_DI_TEMP_w
	jmp  ASCII_SPACE3
ANZEIGE_DI_TEMP_w:
	call ASCII_D
	call ASCII_i_
	jmp  ASCII_SPACE
; ##############################################################################	
ANZEIGE_MI_TEMP:
	tst temp
	brne ANZEIGE_MI_TEMP_w
	jmp  ASCII_SPACE3
ANZEIGE_MI_TEMP_w:
	call ASCII_M
	call ASCII_i_
	jmp  ASCII_SPACE
; ##############################################################################	
ANZEIGE_DO_TEMP:
	tst temp
	brne ANZEIGE_DO_TEMP_w
	jmp  ASCII_SPACE3
ANZEIGE_DO_TEMP_w:
	call ASCII_D
	call ASCII_o_
	jmp  ASCII_SPACE
; ##############################################################################	
ANZEIGE_FR_TEMP:
	tst temp
	brne ANZEIGE_FR_TEMP_w
	jmp  ASCII_SPACE3
ANZEIGE_FR_TEMP_w:
	call ASCII_F
	call ASCII_r_
	jmp  ASCII_SPACE
; ##############################################################################	
ANZEIGE_SA_TEMP:
	tst temp
	brne ANZEIGE_SA_TEMP_w
	jmp  ASCII_SPACE3
ANZEIGE_SA_TEMP_w:
	call ASCII_S
	call ASCII_a_
	jmp  ASCII_SPACE
; ##############################################################################	
ANZEIGE_SO_TEMP:
	tst temp
	brne ANZEIGE_SO_TEMP_w
	jmp  ASCII_SPACE2
ANZEIGE_SO_TEMP_w:
	call ASCII_S
	jmp  ASCII_o_
; ##############################################################################	



