; ##############################################################################
; ##############################################################################
; ##############################################################################
; LW/AM	(153279 KHz)																
SI4735_LW:
	LED_GRUEN_AUS
	LED_GELB_AN
	call TFT_CLEAR
	call ZEILE3
	call TEXT_RADIO
	call TEXT_LW
	call ZEILE5
;-------------------------------------------------------------------------------
	call SI4735_POWER_UP_AM
	; AM_SEEK_BAND_BOTTOM	
	ldi temp1,LOW (AM_SEEK_BAND_BOTTOM)	;Property Low Byte			
	ldi temp2,HIGH(AM_SEEK_BAND_BOTTOM)	;Property High Byte			
	ldi temp3,LOW (153)					;Property Value Low Byte	
	ldi temp4,HIGH(153)					;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; AM_SEEK_BAND_TOP 		
	ldi temp1,LOW (AM_SEEK_BAND_TOP)	;Property Low Byte			
	ldi temp2,HIGH(AM_SEEK_BAND_TOP)	;Property High Byte			
	ldi temp3,LOW (279)					;Property Value Low Byte	
	ldi temp4,HIGH(279)					;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; FREQUENZ				
	ldi temp1,LOW (153)	
	ldi temp2,HIGH(153)	
	call SI4735_AM_TUNE_FREQ_TEMP1_2
	; MODUS					
	ldi temp,(MODUS_LW)
	STS(adr_MODUS_AM_FM),temp
;-------------------------------------------------------------------------------
	call TFT_CLEAR
	LED_GELB_AUS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MW/AM	(5201710 kHz)																
SI4735_MW:
	LED_GRUEN_AUS
	LED_GELB_AN
	call TFT_CLEAR
	call ZEILE3
	call TEXT_RADIO
	call TEXT_MW
	call ZEILE5
;-------------------------------------------------------------------------------
	call SI4735_POWER_UP_AM
	; AM_SEEK_BAND_BOTTOM	
	ldi temp1,LOW (AM_SEEK_BAND_BOTTOM)	;Property Low Byte			
	ldi temp2,HIGH(AM_SEEK_BAND_BOTTOM)	;Property High Byte			
	ldi temp3,LOW (520)					;Property Value Low Byte	
	ldi temp4,HIGH(520)					;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; AM_SEEK_BAND_TOP 		
	ldi temp1,LOW (AM_SEEK_BAND_TOP)	;Property Low Byte			
	ldi temp2,HIGH(AM_SEEK_BAND_TOP)	;Property High Byte			
	ldi temp3,LOW (1710)				;Property Value Low Byte	
	ldi temp4,HIGH(1710)				;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; FREQUENZ				
	ldi temp1,LOW (520)	
	ldi temp2,HIGH(520)	
	call SI4735_AM_TUNE_FREQ_TEMP1_2
	; MODUS					
	ldi temp,(MODUS_MW)
	STS(adr_MODUS_AM_FM),temp
;-------------------------------------------------------------------------------
	LED_GELB_AUS
	call TFT_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KW/AM	(2.321.85 MHz)																
SI4735_KW:
	LED_GRUEN_AUS
	LED_GELB_AN
	call TFT_CLEAR
	call ZEILE3
	call TEXT_RADIO
	call TEXT_KW
	call ZEILE5
;-------------------------------------------------------------------------------
	call SI4735_POWER_UP_AM
	; AM_SEEK_BAND_BOTTOM	
	ldi temp1,LOW (AM_SEEK_BAND_BOTTOM)	;Property Low Byte			
	ldi temp2,HIGH(AM_SEEK_BAND_BOTTOM)	;Property High Byte			
	ldi temp3,LOW (2300)				;Property Value Low Byte	
	ldi temp4,HIGH(2300)				;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; AM_SEEK_BAND_TOP 		
	ldi temp1,LOW (AM_SEEK_BAND_TOP)	;Property Low Byte			
	ldi temp2,HIGH(AM_SEEK_BAND_TOP)	;Property High Byte			
	ldi temp3,LOW (21850)				;Property Value Low Byte	
	ldi temp4,HIGH(21850)				;Property Value High Byte	
	call SI4735_SET_PROPERTY_TEMP1_4
	; FREQUENZ				
	ldi temp1,LOW (2300)	
	ldi temp2,HIGH(2300)	
	call SI4735_AM_TUNE_FREQ_TEMP1_2
	; MODUS					
	ldi temp,(MODUS_KW)
	STS(adr_MODUS_AM_FM),temp
;-------------------------------------------------------------------------------
	LED_GELB_AUS
	call TFT_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; LW/AM	(153279 KHz)																
; MW/AM	(5201710 kHz)																
; KW/AM	(2.321.85 MHz)																
;																					
; ARG1 CTSIEN GPO2OEN PATCH XOSCEN FUNC[3:0]												
; ARG2 OPMODE[7:0]																			
;																							
; ARG1 7 CTSIEN CTS Interrupt Enable. 0 = CTS interrupt disabled. 1 = CTS interrupt enabled.
; ARG1 6 GPO2OEN GPO2 Output Enable. 0 = GPO2 output disabled. 1 = GPO2 output enabled.		
; ARG1 5 PATCH Patch Enable. 0 = Boot normally. 1 = Copy NVM to RAM, but do not boot. After CTS has been set, RAM may be patched.
; ARG1 4 XOSCEN Crystal Oscillator Enable. 0 = Use external RCLK (crystal oscillator disabled). 1 = Use crystal oscillator (RCLK and GPO3/DCLK with external 32.768 kHz crystal and OPMODE=00000101).
;!ARG1 3:0 FUNC[3:0]Function. 0 = Reserved. 1 = AM/SW/LW Receive. 214 = Reserved. 15 = Query Library ID.
; ARG2 7:0 OPMODE[7:0] Application Setting.										
;					00000000 = RDS output only (no audio outputs) Si4749 only	
;					00000101 = Analog audio outputs (LOUT/ROUT).				
;					00001011 = Digital audio output (DCLK, LOUT/DFS, ROUT/DIO)	
;					10110000 = Digital audio outputs (DCLK, DFS, DIO)			
SI4735_POWER_UP_AM:
	call RDS_CLEAR								; RDS clear	
	call SI4735_POWER_DOWN						; AUS		
	; Pause wichtig	
	call wait_1s
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(POWER_UP)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00010001	; 32kHz Quarz, AM
	call TWI_MT_DATA_TEMP1			; ARG		
	ldi temp1,0b00000101	; Analog Output
	call TWI_MT_DATA_TEMP1			; ARG		
	call TWI_STOP								; STOPP		
	; Pause wichtig	
	call wait_1s
	; RX_VOLUME	(0...63 default is 63 dB)
	ldi temp1,(63)	
	rjmp SI4735_VOLUME_SET_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 1 0 0 0 0 0 0															
; ARG1 0 0 0 0 0 0 0 FAST	FAST Tuning. If set, executes fast and invalidated tune. The tune status will not be accurate.
; ARG2 FREQH	[7:0]		Tune frequency in kHz. In AM/SW/LW mode, the valid range is from 149 to 23000 (149 kHz23 MHz). In AM only mode the valid range is from 520 to 1710 (5201710 kHz).
; ARG3 FREQL	[7:0]															
; ARG4 ANTCAPH	[15:8]		Antenna Tuning Capacitor							
; ARG5 ANTCAPL	[7:0]															
SI4735_AM_TUNE_FREQ_TEMP1_2:
	STS(adr_TUNE_FREQUENZ_L),temp1
	STS(adr_TUNE_FREQUENZ_H),temp2

	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(AM_TUNE_FREQ)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00000000	; FAST
	call TWI_MT_DATA_TEMP1			; ARG1		

LDS temp1,(adr_TUNE_FREQUENZ_H);(Frequenz_H)
	call TWI_MT_DATA_TEMP1			; ARG2		
LDS temp1,(adr_TUNE_FREQUENZ_L);(Frequenz_L)

	call TWI_MT_DATA_TEMP1			; ARG3		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG4		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG5		
	call TWI_STOP								; STOPP		

	STS(adr_TUNE_FREQUENZ_L),NULL
	STS(adr_TUNE_FREQUENZ_H),NULL

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 1 0 0 0 0 0 1									
; ARG1 0 0 0 0 SEEKUP WRAP 0 0							
; ARG2 0 0 0 0 0 0 0 0									
; ARG3 0 0 0 0 0 0 0 0									
; ARG4 ANTCAPH											
; ARG5 ANTCAPL											
;														
;!ARG1 3 SEEKUP Seek Up/Down. UP = 1, or DOWN = 0.		
;!ARG1 2 WRAP Wrap/Halt. Determines whether the seek should Wrap = 1, or Halt = 0 when it hits theband limit.
; ARG4 15:8 ANTCAPH[15:8]Antenna Tuning Capacitor 		
; ARG5 7:0 ANTCAPL[7:0]									
SI4735_AM_SEEK_START_UP:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(AM_SEEK_START)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00001000 ; UP/HALT
	call TWI_MT_DATA_TEMP1			; ARG1		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG2		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG3		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG4		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG5		
	jmp TWI_STOP								; STOP		
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 1 0 0 0 0 0 1									
; ARG1 0 0 0 0 SEEKUP WRAP 0 0							
; ARG2 0 0 0 0 0 0 0 0									
; ARG3 0 0 0 0 0 0 0 0									
; ARG4 ANTCAPH											
; ARG5 ANTCAPL											
;														
;!ARG1 3 SEEKUP Seek Up/Down. UP = 1, or DOWN = 0.		
;!ARG1 2 WRAP Wrap/Halt. Determines whether the seek should Wrap = 1, or Halt = 0 when it hits theband limit.
; ARG4 15:8 ANTCAPH[15:8]Antenna Tuning Capacitor 		
; ARG5 7:0 ANTCAPL[7:0]									
SI4735_AM_SEEK_START_DOWN:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(AM_SEEK_START)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0b00000000 ; DOWN/HALT
	call TWI_MT_DATA_TEMP1			; ARG1		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG2		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG3		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG4		
	ldi temp1,0
	call TWI_MT_DATA_TEMP1			; ARG5		
	jmp TWI_STOP								; STOPP		
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_AM_STEPP_UP:
	LDS temp1,(adr_TUNE_FREQUENZ_L)
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	add temp1,EINS
	adc temp2,NULL
	jmp SI4735_AM_TUNE_FREQ_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_AM_STEPP_DOWN:
	LDS temp1,(adr_TUNE_FREQUENZ_L)
	LDS temp2,(adr_TUNE_FREQUENZ_H)
	sub temp1,EINS
	sbc temp2,NULL
	rjmp SI4735_AM_TUNE_FREQ_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_AM_TUNE_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1			; MT-START	
	ldi temp1,(AM_TUNE_STATUS)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0x03
	call TWI_MT_DATA_TEMP1			; ARG1		
	call TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1						; MR-START	
	call TWI_MR_DATA_TEMP1			; STATUS	
	STS(adr_STATUS),temp1		; STATUS		
	call TWI_MR_DATA_TEMP1			; RESP1		
	call TWI_MR_DATA_TEMP1			; RESP2		
	STS(adr_TUNE_FREQUENZ_H),temp1; Frequenz (H)	
	call TWI_MR_DATA_TEMP1			; RESP3		
	STS(adr_TUNE_FREQUENZ_L),temp1; Frequenz (L)	
	call TWI_MR_DATA_TEMP1			; RESP4		
	call TWI_MR_DATA_TEMP1			; RESP5		
	call TWI_MR_DATA_TEMP1			; RESP6		
	call TWI_MR_LAST_DATA_TEMP1		; RESP7		
	jmp TWI_STOP								; STOPP		
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Bit 	D7 	D6 	D5 	D4 	D3 		D2 			D1 			D0			
;STATUS CTS ERR X 	X 	RSQINT 	X 			X 			STCINT		
;RESP1 	X 	X 	X 	X 	SNRHINT SNRLINT 	RSSIHINT 	RSSIILINT	
;RESP2 	X 	X 	X 	X 	SMUTE 	X 			AFCRL 		VALID		
;RESP3 	X 	X 	X 	X 	X 		X 			X 			X			
;RESP4 RSSI															
;RESP5 SNR															
SI4735_AM_RSQ_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MT_START_TEMP1				; MT-START	
	ldi temp1,(AM_RSQ_STATUS)
	call TWI_MT_DATA_TEMP1			; CMD		
	ldi temp1,0x03
	call TWI_MT_DATA_TEMP1			; ARG1		
	call TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	call TWI_MR_START_TEMP1						; MR-START	
	call TWI_MR_DATA_TEMP1			; STATUS	
	STS(adr_STATUS),temp1		; STATUS		
	call TWI_MR_DATA_TEMP1			; RESP1		
	call TWI_MR_DATA_TEMP1			; RESP2		
	call TWI_MR_DATA_TEMP1			; RESP3		
	call TWI_MR_DATA_TEMP1			; RESP4		
	STS(adr_RSSI),temp1
	call TWI_MR_LAST_DATA_TEMP1		; RESP5		
	STS(adr_SNR),temp1
	jmp TWI_STOP					; STOPP		
; ##############################################################################
; ##############################################################################
; ##############################################################################




